# Class: strongspace
#
# This module manages strongspace
#
# Parameters:
#
# Actions:
#
# Requires:
#Class[ruby]
#
# Sample Usage:
#
# [Remember: No empty lines between comments and class definition]
class strongspace (
	$username,
	$password,
	$file_strongspace_sourcedir,
	$cron_strongspace_hour,
	$cron_strongspace_minute,
	$file_strongspace_space			= '`hostname`',
	$file_strongspace_exclude		= '',
	$file_strongspace_path			= '/usr/local/bin',
	$cron_strongspace_user			= 'root',
	$cron_strongspace_user_path	= '/root',
	$enable											= present
	){

	Class["ruby"] 	-> Class["strongspace"]
	Class["expect"]	-> Class["strongspace"]

	#####variables==start#####
	$strongspace_backup_path = "$file_strongspace_path/strongspace_backup"
	$strongspace_expect_path = "$file_strongspace_path/strongspace_expect"
	#####variables==end#####

	#####package==start#####
	#strongspace is not packages so use the gem provider
	package {"strongspace":
		ensure		=> $enable?{
			present	=> latest,
			default	=> absent,
		},
		provider	=> gem
	}
	#####package==end#####

	#####config==start#####
	file { "strongspace_backup":
		path		=> "$strongspace_backup_path",
		content	=> template("$module_name/strongspace_backup.erb"),
		mode		=> 0755,
		owner		=> 'root',
		group		=> 'root',
		ensure	=> $enable,
		require	=> Package["strongspace"]
	}
	file { "strongspace_expect":
		path		=> "$strongspace_expect_path",
		content	=> template("$module_name/strongspace_expect.erb"),
		mode		=> 0755,
		owner		=> 'root',
		group		=> 'root',
		ensure	=> $enable,
		require	=> [Package["expect"], Package["strongspace"]],
	}

	exec { "strongspace_credentials":
		path			=> "/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin",
		command		=> "su -c '$file_strongspace_path/strongspace_expect $username $password' $cron_strongspace_user",
		creates		=> "$cron_strongspace_user_path/Library/Strongspace/credentials/credentials",
		logoutput	=> true,
		require		=> [ Package["strongspace"], File["strongspace_expect"] ],
	}

	cron { "strongspace_backup":
		command	=> $strongspace_backup_path,
		user		=> $cron_strongspace_user,
		hour		=> $cron_strongspace_hour,
		minute	=> $cron_strongspace_minute,
		ensure	=> $enable,
		require	=> [ Package["strongspace"], File["strongspace_backup"], Exec["strongspace_credentials"] ]
	}

	#####config==end#####

}
